/* The code of the third glue example */

#include <iostream>

class MyGaussInt {
  int re;
  int im;
public:
  MyGaussInt () : re(0), im(0) {}
  MyGaussInt (int r, int i) : re(r), im(i) {}
  int real() { return re; }
  int imag() { return im; }
  void set_real(int r) { re = r; }
  void set_imag(int i) { im = i; }

  friend int real(const MyGaussInt& z) { return z.re; }
  friend int imag(const MyGaussInt& z) { return z.im; }
  friend int hash(const MyGaussInt& z) { return (z.im + z.re); }
};

inline bool 
operator == (const MyGaussInt& a, const MyGaussInt& b) {
  return (real(a) == real(b) ? (imag(a) == imag(b) ? true : false) : false);
}

inline bool 
operator != (const MyGaussInt& a, const MyGaussInt& b) {
  return (!(a == b) );
}

MyGaussInt
operator+ (const MyGaussInt& x, const MyGaussInt& y) {
  return MyGaussInt (real(x) + real(y) , imag(x) + imag(y));
}

MyGaussInt
operator- (const MyGaussInt& x, const MyGaussInt& y) {
  return MyGaussInt (real(x) - real(y), imag(x) - imag(y));
}

std::ostream&
operator<< (std::ostream& os, const MyGaussInt z) {
  return os << "[ " << real(z) << "," << imag(z) << " ]";
}

