<TeXmacs|1.0.5.12>

<style|<tuple|mmxdoc|mathemagix>>

<\body>
  <\tmdoc-title>
    Mathemagix

    Warming-up using mathemagix under <TeXmacs>
  </tmdoc-title>

  Mathemagix (Mmx for short) is a (for the moment) prototypal computer
  algebra system allowing to use external library (glue codes).

  <section|How to launch a session under <TeXmacs>>

  We assume here that the installation of both <TeXmacs>, Mathemagix, mmxlib
  and Synaps are complete and run well.

  <\enumerate-numeric>
    <item>Go on the menu <verbatim|Insert>;

    <item>Select <verbatim|session>;

    <item>Choose <verbatim|Mathemagix> and a Mathemagix session is launched
    in the current <TeXmacs> window.
  </enumerate-numeric>

  You may obtain the following frame :

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\output>
      ------------------------------------------------------------

      \|:*) \ \ \ \ \ \ \ \ \ \ \ Welcome to Mathemagix 0.1.47
      \ \ \ \ \ \ \ \ \ \ \ (*:\|

      \| \ \ \ \ \ (c) 2001--2005 \ by Joris van der Hoeven et al.
      \ \ \ \ \ \|

      \| This software falls under the GNU General Public License \|

      \| \ \ \ \ \ \ \ \ It comes without any warranty whatsoever
      \ \ \ \ \ \ \ \ \|

      ------------------------------------------------------------
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      \;
    </input>
  </session>>

  <section|Mathemagix as a calculator>

  If you have few operations to perform, you can use mathemagix as calculator
  :

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      2+2;
    </input>

    <\output>
      <with|mode|math|4> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      2^300;
    </input>

    <\output>
      <with|mode|math|2037035976334486086268445688409378161051468393665936250636140449354381299763336706183397376>
      <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      0.1*0.2341;
    </input>

    <\output>
      <with|mode|math|2.341000000000000*10<rsup|\<um\>2>> <right-flush>
      <with|mode|math|color|brown|mode|text|Floating>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      0.1^3;
    </input>

    <\output>
      <with|mode|math|1.000000000000000*10<rsup|\<um\>3>> <right-flush>
      <with|mode|math|color|brown|mode|text|Floating>
    </output>
  </session>>

  Mathemagix provides most of what a classical calculator provides with
  multiprecision for integers, rational, ... and a few more as we will see.

  <section|Variables : declaration, affectation.>

  Mathemagix is a strongly typed system, i.e. all the objet existing in the
  system must have a type and the user may take care of it (just like if you
  program in C or C++). So the first think to do to declare a variable is to
  think about is type.\ 

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a : Integer := 2
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a
    </input>

    <\output>
      <with|mode|math|2> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a := 3
    </input>

    <\output>
      <with|mode|math|3> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a:=2
    </input>

    <\output>
      <with|mode|math|2> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>
  </session>>

  Hereabove, you have a first exemple declaration and affectation of a
  variable. The syntax is the following :

  <block*|<tformat|<table|<row|<cell|<verbatim|name_of_the_variable>>|<cell|<verbatim|:>>|<cell|<verbatim|type_of_the_variable>>|<cell|<verbatim|:=>>|<cell|<verbatim|value_to_be_affected>>>>>>

  <block*|<tformat|<table|<row|<cell|<verbatim|name_of_the_variable>>|<cell|<verbatim|:=>>|<cell|<verbatim|value_to_be_affected>>>>>>

  The \S <verbatim|:> \T are use for the type and the <verbatim|:=> for the
  value.

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      b : Rational := 2/3;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      b
    </input>

    <\output>
      <with|mode|math|<frac|2|3>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Rational><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a : Rational := a/1*b;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a
    </input>

    <\output>
      <with|mode|math|<frac|4|3>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Rational><right|)>>

      <with|mode|math|2> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Integer><right|)>>
    </output>
  </session>>

  Here you have a first exemple of a concept that will discuss later in more
  details : the variable \S <verbatim|a> \T has several types and values !

  You must be really carefull with the types (no implicit coersion) :

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      c : Integer := 2
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      f : Rational := c
    </input>

    <\output>
      fun= #value\<less\>#function\<less\>id\<gtr\> (-\<gtr\> (Cross
      Rational) Rational)\<gtr\>

      args= (#value\<less\>#alias\<less\>#glued\<less\>2
      Integer\<gtr\>\<gtr\> (Alias Integer)\<gtr\>)

      <\errput>
        Unknown location: Invalid function application

        \| (#value\<less\>#function\<less\>id\<gtr\> (-\<gtr\> (Cross
        Rational) Rational)\<gtr\> #value\<less\>#alias\<less\>#glued\<less\>2
        Integer\<gtr\>\<gtr\> (Alias Integer)\<gtr\>)
      </errput>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      f : Rational := c/1
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      f
    </input>

    <\output>
      <with|mode|math|2> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Rational><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      g : Integer == f
    </input>

    <\output>
      fun= #value\<less\>#function\<less\>id\<gtr\> (-\<gtr\> (Cross Integer)
      Integer)\<gtr\>

      args= (#value\<less\>#alias\<less\>#glued\<less\>2
      Rational\<gtr\>\<gtr\> (Alias Rational)\<gtr\>)

      <\errput>
        Unknown location: Invalid function application

        \| (#value\<less\>#function\<less\>id\<gtr\> (-\<gtr\> (Cross
        Integer) Integer)\<gtr\> #value\<less\>#alias\<less\>#glued\<less\>2
        Rational\<gtr\>\<gtr\> (Alias Rational)\<gtr\>)
      </errput>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      g : Integer := c
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      g
    </input>

    <\output>
      <with|mode|math|2> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Integer><right|)>>
    </output>
  </session>>

  For the moment, the \ \S types system \T is very rigid but it allows very
  rigorous implementation.

  <with|prog-language|mathemagix|prog-session|default|<\session>
    \;

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      P : Polynomial(Integer) := polynomial(1,2,1);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      P
    </input>

    <\output>
      <with|mode|math|x<rsup|2>+2*x+1> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Polynomial><left|(><with|mode|text|Integer><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      Q : Polynomial(Integer) == P*P*P;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      Q;
    </input>

    <\output>
      <with|mode|math|x<rsup|6>+6*x<rsup|5>+15*x<rsup|4>+20*x<rsup|3>+15*x<rsup|2>+6*x+1>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Polynomial><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      Q :Polynomial(Integer) := P^20;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      Q
    </input>

    <\output>
      <with|mode|math|x<rsup|40>+40*x<rsup|39>+780*x<rsup|38>+9880*x<rsup|37>+91390*x<rsup|36>+658008*x<rsup|35>+3838380*x<rsup|34>+18643560*x<rsup|33>+76904685*x<rsup|32>+273438880*x<rsup|31>+847660528*x<rsup|30>+2311801440*x<rsup|29>+5586853480*x<rsup|28>+12033222880*x<rsup|27>+23206929840*x<rsup|26>+40225345056*x<rsup|25>+62852101650*x<rsup|24>+88732378800*x<rsup|23>+113380261800*x<rsup|22>+131282408400*x<rsup|21>+137846528820*x<rsup|20>+131282408400*x<rsup|19>+113380261800*x<rsup|18>+88732378800*x<rsup|17>+62852101650*x<rsup|16>+40225345056*x<rsup|15>+23206929840*x<rsup|14>+12033222880*x<rsup|13>+5586853480*x<rsup|12>+2311801440*x<rsup|11>+847660528*x<rsup|10>+273438880*x<rsup|9>+76904685*x<rsup|8>+18643560*x<rsup|7>+3838380*x<rsup|6>+658008*x<rsup|5>+91390*x<rsup|4>+9880*x<rsup|3>+780*x<rsup|2>+40*x+1>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Polynomial><left|(><with|mode|text|Integer><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      R : Polynomial(Integer) := polynomial(1,1,1);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      R := P - R;
    </input>

    <\output>
      <with|mode|math|x> <right-flush> <with|mode|math|color|brown|<with|mode|text|Polynomial><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      R += P;
    </input>

    <\output>
      <with|mode|math|x<rsup|2>+3*x+1> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Polynomial><left|(><with|mode|text|Integer><right|)>>
    </output>
  </session>>

  A other very current data type is \S Table \T, basically associative
  tables.

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T : Table(Integer,Integer) := table(1)
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T;
    </input>

    <\output>
      <with|mode|math|<left|[><right|]>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Table><left|(><with|mode|text|Integer>,<with|mode|text|Integer><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T[1] := 2;
    </input>

    <\output>
      <with|mode|math|2> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T;
    </input>

    <\output>
      <with|mode|math|<left|[><left|[>1,2<right|]><right|]>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Table><left|(><with|mode|text|Integer>,<with|mode|text|Integer><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T[4] := 12;
    </input>

    <\output>
      <with|mode|math|12> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T;
    </input>

    <\output>
      <with|mode|math|<left|[><left|[>4,12<right|]>,<left|[>1,2<right|]><right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Table><left|(><with|mode|text|Integer>,<with|mode|text|Integer><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T[3];
    </input>

    <\output>
      <with|mode|math|1> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      TT : Table(Integer,String) := table("toto");
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      TT[3] := "titi"
    </input>

    <\output>
      "titi" <right-flush> <with|mode|math|color|brown|mode|text|String>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      TT;
    </input>

    <\output>
      <with|mode|math|<left|[><left|[>3,<with|mode|text|"titi"><right|]><right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Table><left|(><with|mode|text|Integer>,<with|mode|text|String><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      TT[2];
    </input>

    <\output>
      "toto" <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|String><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      TT[3];
    </input>

    <\output>
      "titi" <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|String><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L : Table(String,String) := table("Empty guy");
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L["Flour de coucoudum"] := "to make donuts"
    </input>

    <\output>
      "to make donuts" <right-flush> <with|mode|math|color|brown|mode|text|String>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L["Arriba"] := "mouse singer"
    </input>

    <\output>
      "mouse singer" <right-flush> <with|mode|math|color|brown|mode|text|String>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L;
    </input>

    <\output>
      <with|mode|math|<left|[><left|[><with|mode|text|"Arriba">,<with|mode|text|"mouse
      singer"><right|]>,<left|[><with|mode|text|"Flour de
      coucoudum">,<with|mode|text|"to make donuts"><right|]><right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Table><left|(><with|mode|text|String>,<with|mode|text|String><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L["Arriba"];
    </input>

    <\output>
      "mouse singer" <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|String><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L["Caramba"]
    </input>

    <\output>
      "Empty guy" <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|String><right|)>>
    </output>
  </session>>

  <tmdoc-copyright|2005|Joris van der Hoeven|Bernard Mourrain|Olivier Ruatta>

  <tmdoc-license|Permission is granted to copy, distribute and/or modify this
  document under the terms of the <hlink|GNU General Public
  License|http://www.gnu.org/licenses/gpl.txt>. If you don't have this file,
  write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.>
</body>

<\initial>
  <\collection>
    <associate|language|english>
  </collection>
</initial>