
/******************************************************************************
* MODULE     : evaluator.cc
* DESCRIPTION: The mathemagix evaluator type
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
namespace mmx {

extern int cycle_depth;

/******************************************************************************
* Required routines for generic structures
******************************************************************************/

size_t
evaluator_rep::Size () {
  return sizeof (evaluator_rep);
}

void
evaluator_rep::Mark () {
  mark (env);
  mark (cur);
  mark (rem);
  mark (trace);
}

int
evaluator_rep::Type () {
  return EVALUATOR_TYPE;
}

void
evaluator_rep::Print (ostream& out) {
  out << evaluator (this);
}

/******************************************************************************
* Printing
******************************************************************************/

ostream&
operator << (ostream& out, evaluator ev) {
  if (current_print_format == normal ||
      current_print_format == condensed ||
      cycle_depth <= 0)
    return out << "evaluator<" << ((int) ((long) ev.rep)) << ">";
  else if (current_print_format == indented) {
    cycle_depth--;
    out << "#evaluator";
    current_indentation++;
    out << lf << ev->cur;
    out << lf << ev->rem;
    out << lf << ev->trace;
    out << lf << ev->env;
    current_indentation--;
    cycle_depth++;
    return out;
  }
  else {
    cycle_depth--;
    out << "#evaluator<" << ev->cur << " " << ev->rem
	<< " " << ev->trace << " " << ev->env << ">";
    cycle_depth++;
    return out;
  }
}

} // namespace mmx
