
/******************************************************************************
* MODULE     : pointer.cc
* DESCRIPTION: pointers
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <pointer.hh>
#include <symbol.hh>
namespace mmx {

/******************************************************************************
* Required routines for generic structures
******************************************************************************/

size_t
pointer_rep::Size () {
  return sizeof (pointer_rep);
}

void
pointer_rep::Mark () {
  mark (ptr);
}

int
pointer_rep::Type () {
  return POINTER_TYPE;
}

int
pointer_rep::Hash () {
  return ((int) ((long) ptr)) >> 3;
}

bool
pointer_rep::Equal (generic g) {
  if (gentype (g) != POINTER_TYPE) return false;
  return pointer (this) == as_pointer (g);
}

generic
pointer_rep::Copy () {
  return copy (pointer (this));
}

void
pointer_rep::Print (ostream& out) {
  out << pointer (this);
}

/******************************************************************************
* Routines for pointers
******************************************************************************/

ostream&
operator << (ostream& out, pointer f) {
  return out << "#pointer<" << f->ptr << ">";
}

pointer
copy (pointer ptr) {
  return pointer (ptr->ptr);
}

} // namespace mmx
