
/******************************************************************************
* MODULE     : serializer.hh
* DESCRIPTION: mathemagix output streams
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __SERIALIZER_HH
#define __SERIALIZER_HH
#include <string.hh>
#include <printer.hh>

#ifdef OLD_CPP
#include <strstream>
using std::ostrstream;
typedef ostrstream ostringstream;
#else
#include <sstream>
using std::ostringstream;
#endif

namespace mmx {

NO_MARKING(ostringstream);

class serializer;
class serializer_rep: public generic_rep {
public:
  ostringstream out;

protected:
  size_t Size ();
  void Mark ();
  int Type ();
  void Print (ostream& out);

public:
  inline serializer_rep () {}

  friend class serializer;
  friend serializer copy (serializer t);
  friend ostream& operator << (ostream& out, serializer a);
};

class serializer {
DEFAULT_METHODS(serializer);
public:
  inline serializer ():
    rep (new serializer_rep ()) {}

  friend ostream& operator << (ostream& out, serializer a);
};

string as_string (serializer ser);
printer as_printer (serializer ser);

}
#endif // __SERIALIZER_HH
